//Copyright (C) 2010+ Phoenix.

//This program is free software: you can redistribute it and/or modify 
//it under the terms of the GNU General Public License as published by 
//the Free Software Foundation, version 2.0. 

//This program is distributed in the hope that it will be useful, 
//but WITHOUT ANY WARRANTY; without even the implied warranty of 
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//GNU General Public License 2.0 for more details. 

//A copy of the GPL 2.0 should have been included with the program. 
//If not, see http://www.gnu.org/licenses/ 

//Source code and contact information can be found at 
//https://github.com/marco-calautti


#ifndef __DeltaPatcherDecodePanel__
#define __DeltaPatcherDecodePanel__

/**
@file
Subclass of DecodePanel, which is generated by wxFormBuilder.
*/

#include "DeltaPatcherDropHandler.h"
#include "dpgui.h"
#include "Logger.h"

#include <patcher/XDeltaPatch.h>

#include <wx/thread.h>
#include <wx/event.h>

/** Implementing DecodePanel */
class DeltaPatcherDecodePanel : public DecodePanel, public DeltaPatcherDropHandler, public wxThreadHelper
{
protected:
	// Handlers for DecodePanel events.
	void OnOpenOriginal( wxCommandEvent& event );
	void OnOpenPatch( wxCommandEvent& event );
	void OnApplyPatch( wxCommandEvent& event );
	void OnDecodeOptionsClicked(wxCommandEvent& event);

	virtual wxThread::ExitCode Entry();
	void ShowPatchDescriptionToolTip(const wxString& patchDesc);
public:
	/** Constructor */
	DeltaPatcherDecodePanel( wxWindow* parent,Logger* logger );
	
	void SwitchTo();
	void SetPatchFile(const wxChar* patchPath);
	void SetOriginalFile(const wxChar* filePath);
	virtual bool HandleFileDrop(const wxArrayString& filenames);
	
	void OnThreadUpdate(wxThreadEvent& evt);
	void StartApplyPatch();
private:
	Logger* logger;
	wxMenu* applyOptionsMenu;
	wxMenuItem* keepOriginalCheck;
	wxMenuItem* checksumCheck;

	wxString threadOriginal;
	wxString threadModified;
	XDeltaPatch threadXDP;
};

#endif // __DeltaPatcherDecodePanel__
